/* NAME: Kirill Vasil'evich Timofeev, 322
 * ASGN: N1
 */

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include "liblinear-1.8\linear.h"
#include "Logic.h"
#include "math.h"

#define Malloc(type,n) (type *)malloc((n)*sizeof(type))
  const int NUM_FEATURES = 2000;

Logic::Logic(){}

Logic::~Logic(){}

bool Logic::getFilesTr()
{
    trainFeatures.clear();
    trainLabels.clear();
    inFile = new QFile(curInFile);
    if (!inFile->open(QIODevice::ReadOnly)) return false;
    char temp2[200];
    int Num, Xmin, Ymin, Xmax, Ymax;
    outFile = new QFile(curOutFile);
    outFile->open(QIODevice::WriteOnly | QIODevice::Truncate);
    int cnt = 0;
    curHist = new int[2000];
    while ((inFile->readLine(temp2, 200)) > 0)
    {
        sscanf(temp2, "%d %d %d %d %d", &Num, &Ymin, &Xmin, &Ymax, &Xmax);
        getFileNameFromInt(Num);
        if (cnt > 0)
        {
            delete curImage;
        }
        curImage = new QImage();
        curImage->load(*curFile);
        for (int j = 0; j <= 1999; j++)
            curHist[j] = 0;
        makeHOG(Ymin, Xmin, Ymax, Xmax);
        trainModel(true);
        int t = curImage->width();
        for (int m = 0; m < t - 80; m += 10)
        {
            if ((m < (Xmin - 60)) || (m > (Xmax - 20)))
            {
                for (int j = 0; j <= 1999; j++)
                    curHist[j] = 0;
                makeHOG(Ymin, m, Ymax, m + 80);
                trainModel(false);
            }
       }

        cnt++;

    }
    delete[] curHist;
    makeModel();
    inFile->close();
    outFile->close();

    return true;
}

bool Logic::getFilesSDir()
{
    inFile = new QFile(curInFile);
    if (!inFile->open(QIODevice::ReadOnly)) return false;
    char temp2[200];
    int Num;

    while (inFile->readLine(temp2, 200) > 0)
    {
        sscanf(temp2, "%d", &Num);
        getFileNameFromInt(Num);
        if (!useImage(Num)) return false;

    }
    delete[] curHist;

    return true;
}

bool Logic::getFilesSImg()
{
    int Num = 0;
    curFile = new QString(curInFile);
    if (!useImage(Num)) return false;
    delete[] curHist;

    return true;
}

bool Logic::useImage(int Num)
{
    char temp2[200];
    curImage = new QImage;
    if (!curImage->load(*curFile)) return false;
    if (!outFile->open(QIODevice::Append)) return false;
    curHist = new int[2000];
    for (int j = 0; j <= 1999; j++)
        curHist[j] = 0;
    for (int X = 0; X < (curImage->width() - 80); X += 5)
    {
        for (int j = 0; j <= 1999; j++)
            curHist[j] = 0;
        makeHOG(0, X, 200, X + 80);
        bool b = testModel();
        if (b)
        {
            sprintf(temp2, "%d  %d  %d  %d  %d", Num, 0, X, 200 ,X + 80);
            paint(0, X, 200, X + 80);
            outFile->write(temp2);
            outFile->write("\n");
            outFile->flush();
        }
    }
    outFile->close();

    return true;
}

void Logic::paint(int Ymin, int Xmin, int Ymax, int Xmax)
{
    int i , k;
    for (i = Xmin + 2; i <  Xmax - 2; i++)
        for (k = (-1); k <  2; k++)
        {
            curImage->setPixel(i + k , Ymin, qRgb(0 ,255 ,0));
            curImage->setPixel(i + k , Ymax, qRgb(0 ,255 ,0));
        }
    for (i = Ymin + 1; i <  Ymax - 2; i++)
        for (k = (-1); k <  2; k++)
        {
            curImage->setPixel(Xmin , i + k, qRgb(0 ,255 ,0));
            curImage->setPixel(Xmax , i + k, qRgb(0 ,255 ,0));
        }

}

void Logic::getFileNameFromInt(int i)
{
    int tc , td  , te;
    char c , d , e , f = '\\';
    QString ras = ".png";
    int k = 4;
    tc = i / 100;
    td = (i - tc * 100) / 10;
    te = i - tc * 100 - td * 10;
    if (tc == 0)
    {
        c = '0';
        k--;
    }
     else c = '0' + tc;
    if ((td == 0) && (tc == 0))
    {
        d = '0';
        k--;
    }
     else d = '0' + td;
    e = '0' + te;
    curFile = new QString(curCat);
    *curFile +=  f;
    if (k > 3) *curFile += c;
    if (k > 2) *curFile += d;
    *curFile += e;
    *curFile += ras;

    char temp[8];
    temp[0] = c;
    temp[1] = d;
    temp[2] = e;
    temp[3] = '.';
    temp[4] = 'p';
    temp[5] = 'n';
    temp[6] = 'g';
    temp[7] = '\0';
    //statusBar()->showMessage(temp, 2000);
}

void Logic::makeHOG(int Ymin, int Xmin, int Ymax, int Xmax)
{
    int N = 3;
    int **wind1;
    wind1 = new int*[3];
    for (int i = 0; i < 3; i++)
                wind1[i] = new int[3];
    wind1[0][0] = 1;
    wind1[1][0] = 2;
    wind1[2][0] = 1;
    wind1[0][1] = 0;
    wind1[1][1] = 0;
    wind1[2][1] = 0;
    wind1[0][2] = -1;
    wind1[1][2] = -2;
    wind1[2][2] = -1;

    int **tempXred;
    tempXred = new int*[curImage->width()];
    for (int i = 0; i < curImage->width(); i++)
            tempXred[i] = new int[curImage->height()];

    int **tempXgreen;
    tempXgreen = new int*[curImage->width()];
    for (int i = 0; i < curImage->width(); i++)
            tempXgreen[i] = new int[curImage->height()];

    int **tempXblue;
    tempXblue = new int*[curImage->width()];
    for (int i = 0; i < curImage->width(); i++)
            tempXblue[i] = new int[curImage->height()];

    int **tempYred;
    tempYred = new int*[curImage->width()];
    for (int i = 0; i < curImage->width(); i++)
            tempYred[i] = new int[curImage->height()];

    int **tempYgreen;
    tempYgreen = new int*[curImage->width()];
    for (int i = 0; i < curImage->width(); i++)
            tempYgreen[i] = new int[curImage->height()];

    int **tempYblue;
    tempYblue = new int*[curImage->width()];
    for (int i = 0; i < curImage->width(); i++)
            tempYblue[i] = new int[curImage->height()];


    wash(tempXred, tempXgreen, tempXblue, Ymin, Xmin, Ymax, Xmax, N, wind1 , true);

    wash(tempYred, tempXgreen, tempYblue, Xmin, Ymin, Xmax, Ymax, N, wind1 , false);

    double Angle, green, blue, red;
    int Num;
    for (int i = Xmin; i < Xmax; i++)
    {
        for (int j = Ymin; j < Ymax; j++)
        {
            double PI = asin(1) * 2;
            Num = (((j - Ymin) / 8) * 10 + ((i - Xmin) / 8)) * 8;
            if (tempXred[i][j]) red = atan((double)tempYred[i][j] / tempXred[i][j]) + PI / 2;
            else red = PI / 2;
            if (tempXgreen[i][j]) green = atan((double)tempYgreen[i][j] / tempXgreen[i][j]) + PI / 2;
            else green = PI / 2;
            if (tempXblue[i][j]) blue = atan((double)tempYblue[i][j] / tempXblue[i][j]) + PI / 2;
            else blue = PI / 2;
            if (red > blue) Angle = red;
            else Angle = blue;
            if (green > Angle) Angle = green;
            curHist[Num + (int)trunc(Angle / PI * 8 )]++;
        }
    }


    for (int i = 0; i < curImage->width(); i++)
            delete[] tempXred[i];
    delete[] tempXred;

    for (int i = 0; i < curImage->width(); i++)
            delete[] tempXgreen[i];
    delete[] tempXgreen;

    for (int i = 0; i < curImage->width(); i++)
            delete[] tempXblue[i];
    delete[] tempXblue;

    for (int i = 0; i < curImage->width(); i++)
            delete[] tempYred[i];
    delete[] tempYred;

    for (int i = 0; i < curImage->width(); i++)
            delete[] tempYgreen[i];
    delete[] tempYgreen;

    for (int i = 0; i < curImage->width(); i++)
            delete[] tempYblue[i];
    delete[] tempYblue;

    return;
}

void Logic::trainModel(const bool t)
{

  // PARSE INPUT and split into train and test data

    std::vector<double> features(NUM_FEATURES);
    for (int j = 0; j < NUM_FEATURES; j++)
        features[j] = curHist[j];

    int intLab;
    if (t) intLab = 1;
     else intLab = (-1);

    // odd cnt => instance goes to test set, even => to train set
    trainFeatures.push_back(features);
    trainLabels.push_back(intLab);

  assert(trainLabels.size() == trainFeatures.size());
}

void Logic::makeModel()
{
  // FILL TRAIN STRUCTURE AND TRAIN
  struct problem prob;
  prob.l = int(trainLabels.size()); // number of instances
  prob.bias = -1; // bias feature
  prob.n = NUM_FEATURES; // number of features + one for bias if needed

  prob.y = Malloc(int, prob.l); // allocate space for labels
  prob.x = Malloc(struct feature_node *, prob.l); // allocate space for features

  for (size_t i = 0; i < trainLabels.size(); i++)
  {
    prob.x[i] = Malloc(struct feature_node, NUM_FEATURES+1);
    prob.x[i][NUM_FEATURES].index = -1;  // -1 marks the end of list
    for (int j = 0; j < NUM_FEATURES; j++)
    {
      prob.x[i][j].index = 1+j; // 1-based feature number
      prob.x[i][j].value = trainFeatures[i][j];
    }
    prob.y[i] = trainLabels[i];
  }


  // default values of params. don't change them if not sure (unless param.C)
  struct parameter param;
  param.solver_type = L2R_L2LOSS_SVC_DUAL;
  param.C = 1;
  param.eps = 1e-4;
  param.nr_weight = 0;
  param.weight_label = NULL;
  param.weight = NULL;

  struct model* myModel = train(&prob, &param);

  // SAVE MODEL FOR PREDICTION

  if(save_model(qPrintable(curModelFile), myModel))
  {
    std:: cerr << "can't save model to file " << std::endl;
    return;
  }

  free_and_destroy_model(&myModel);
  destroy_param(&param);
  free(prob.y);
  for (int i = 0; i < prob.l; i++) free(prob.x[i]);
  free(prob.x);
  return;
}

bool Logic::testModel()
{
  struct feature_node* x = Malloc(struct feature_node, NUM_FEATURES+1);
  x[NUM_FEATURES].index = -1;  // -1 marks the end of list

    for (int j = 0; j < NUM_FEATURES; j++)
    {
      x[j].index = 1+j; // 1-based feature number
      x[j].value = curHist[j];
    }

    int predict_label = predict(myModel,x);
  free(x);



  if (predict_label >= 0) return (true);
  else return (false);
}

void Logic::wash(int **TempRed, int **TempGreen, int **TempBlue,int koef1, int koef2, int koef3, int koef4, int N, int **wind, bool a)
{
    int i , j , k, l;
    double red, green, blue;

    for (i = koef1; i < koef3; i++)
        for (j = koef2; j < koef4; j++)
        {
            red = 0;
            green = 0;
            blue = 0;
            for (k = 2 - N ; k < N - 1 ; k++)
                for (l = 2 - N ; l < N - 1 ; l++)
                    if (((j + k) >= koef2) && ((j + k) < koef4) && ((i + l) >= koef1) && ((i + l) < koef3))
                    {
                        if (a)
                        {
                            red +=qRed(curImage->pixel(j + k,i + l)) * wind[k + 1][l + 1];
                            green +=qGreen(curImage->pixel(j + k,i + l)) * wind[k + 1][l + 1];
                            blue +=qBlue(curImage->pixel(j + k,i + l)) * wind[k + 1][l + 1];
                        }
                        else
                        {
                            red +=qRed(curImage->pixel(i + l,j + k)) * wind[k + 1][l + 1];
                            green +=qGreen(curImage->pixel(i + l,j + k)) * wind[k + 1][l + 1];
                            blue +=qBlue(curImage->pixel(i + l,j + k)) * wind[k + 1][l + 1];
                        }
                    }
            if (a)
            {
                TempRed[j][i]= red;
                TempGreen[j][i]= green;
                TempBlue[j][i]= blue;
            }
            else
            {
                TempRed[i][j] = red;
                TempGreen[i][j] = green;
                TempBlue[i][j] = blue;
            }
        }
}

char* Logic::PRcount()
{
    char *temp = new char[200];
    inFile = new QFile(curInFile);
    if (!inFile->open(QIODevice::ReadOnly)) return "Error";
    outFile = new QFile(curModelFile);
    if (!outFile->open(QIODevice::ReadOnly)) return "Error";
    std::vector< std::vector<int> > My;
    std::vector< std::vector<int> > Need;
    int Num, Xmin, Ymin, Xmax, Ymax;

    while ((inFile->readLine(temp, 200)) > 0)
    {
        std::vector<int> Cur(5);
        sscanf(temp, "%d %d %d %d %d", &Num, &Ymin, &Xmin, &Ymax, &Xmax);
        Cur[0] = Num;
        Cur[1] = Ymin;
        Cur[2] = Xmin;
        Cur[3] = Ymax;
        Cur[4] = Xmax;

        My.push_back(Cur);
    }
    char temp2[200];
    int t = outFile->readLine(temp2, 200);
    while (t > 0)
    {
        std::vector<int> Cur(5);
        sscanf(temp2, "%d %d %d %d %d", &Num, &Ymin, &Xmin, &Ymax, &Xmax);
        Cur[0] = Num;
        Cur[1] = Ymin;
        Cur[2] = Xmin;
        Cur[3] = Ymax;
        Cur[4] = Xmax;

        Need.push_back(Cur);
        t = outFile->readLine(temp2, 200);
    }

    int i , j, TP1 = 0, TP = 0, GT = Need.size(), DET = My.size();
    bool b = true;
    for (i = 0; i < GT; i++)
    {
        for (j = 0; j < DET; j++)
        {
            if (My[j][0] == Need[i][0])
            {
                if (((My[j][2] + 40) >= Need[i][2]) && ((My[j][4] - 40) <= Need[i][4]))
                {
                    if (b) TP1++;
                    TP++;
                    b = false;
                }
            }
            else b = true;
        }
    }
    double Recall = (double)TP1 / GT, Precision = (double)TP / DET;
    if (GT == 0) Recall = 0;
    if (DET == 0) Precision = 0;

    sprintf(temp, "Recall = %lf, Precision = %lf ", Recall, Precision);
    inFile->close();
    outFile->close();

    return temp;
}
